# community.routeros.command module – Run commands on remote devices running MikroTik RouterOS

Note

This module is part of the community.routeros collection (version 2.7.0).

To install it, use: `ansible-galaxy collection install community.routeros`.

To use it in a playbook, specify: `community.routeros.command`.

- Synopsis

- Parameters

- Attributes

- Notes

- See Also

- Examples

- Return Values

## Synopsis

- Sends arbitrary commands to an RouterOS node and returns the results read from the device. This module includes an argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.

- The module always indicates a (changed) status. You can use the changed_when task property to determine whether a command task actually resulted in a change or not.

## Parameters

Parameter | Comments
--- | ---
commands list / elements=string / required | List of commands to send to the remote RouterOS device over the configured provider. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retries has expired.
interval integer | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditions, the interval indicates how long to wait before trying the command again. Default: `1`

match

string

The match argument is used in conjunction with the wait_for argument to specify the match policy. Valid values are `all` or `any`. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.

Choices:

- `"any"`

- `"all"` ← (default)

retries integer | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditions. Default: `10`
wait_for list / elements=string | List of conditions to evaluate against the output of the command. The task will wait for each condition to be true before moving forward. If the conditional is not true within the configured number of retries, the task fails. See examples.

## Attributes

Attribute | Support | Description
--- | --- | ---
check_mode | Support: partial The module claims to support check mode, but it simply always executes the command. | Can run in `check_mode` and return changed status prediction without modifying target.
diff_mode | Support: none | Will return details on what has changed (or possibly needs changing in `check_mode`), when in diff mode.
platform | Platform: RouterOS | Target OS/families that can be operated against.

## Notes

Note

- The module declares that it supports check mode. This is a bug and will be changed in community.routeros 3.0.0.

## See Also

See also

How to connect to RouterOS devices with SSH

  How to connect to RouterOS devices with SSH

How to quote and unquote commands and arguments

  How to quote and unquote commands and arguments

## Examples

    - name: Run command on remote devices
      community.routeros.command:
        commands: /system routerboard print

    - name: Run command and check to see if output contains routeros
      community.routeros.command:
        commands: /system resource print
        wait_for: result[0] contains MikroTik

    - name: Run multiple commands on remote nodes
      community.routeros.command:
        commands:
          - /system routerboard print
          - /system identity print

    - name: Run multiple commands and evaluate the output
      community.routeros.command:
        commands:
          - /system routerboard print
          - /interface ethernet print
        wait_for:
          - result[0] contains x86
          - result[1] contains ether1

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Description
--- | ---
failed_conditions list / elements=string | The list of conditionals that have failed Returned: failed Sample: `["...", "..."]`
stdout list / elements=string | The set of responses from the commands Returned: always apart from low level errors (such as action plugin) Sample: `["...", "..."]`
stdout_lines list / elements=string | The value of stdout split into a list Returned: always apart from low level errors (such as action plugin) Sample: `[["...", "..."], ["..."], ["..."]]`

### Authors

- Egor Zaitsev (@heuels)

### Collection links

Issue Tracker Repository (Sources) Submit a bug report Request a feature Communication